/*
 * Copyright (c) 2004, University of Illinois,Distributed Systems Group 
 * Large & Dynamic Groups Size Estimation project members:
 * Dimitrios Psaltoulis
 * Dionysios Kostoulas
 * Indranil Gupta
 * Al Demers
 * Ken Birman
 *  All rights reserved.
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the
 * distribution.
 *
 * - Neither the name of the University of Illinois, Urbana-Champaign
 * nor the names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * GossipInfo.java
 *
 * Created on June 17, 2004, 12:57 PM
 */

package SizeEstimationAlgorithm.HopCounting;

/**
 *
 * @author  dimitrios psaltoulis
 */
public class GossipInfo {
    
    GossipInfo(int hDist, int msgRcv, int msgSent) {
        hopDistance = hDist;
        numberOfMessagesReceived = msgRcv;
        numberOfMessagesSent = msgSent;
    }
    
    public int getHopDistance() { return hopDistance; }
    public void setHopDistance(int hDist) { hopDistance = hDist; }
    public int getNumberOfMessagesReceived() { return numberOfMessagesReceived; }
    public void setNumberOfMessagesReceived(int msgRcv) { numberOfMessagesReceived = msgRcv; }
    public void incNumberOfMessagesReceived() { ++numberOfMessagesReceived; }
    public int getNumberOfMessagesSent() { return numberOfMessagesSent; }
    public void setNumberOfMessagesSent(int msgSent) { numberOfMessagesSent = msgSent; }
    public void incNumberOfMessagesSent() { ++numberOfMessagesSent; }
    
    private int hopDistance;
    private int numberOfMessagesReceived;
    private int numberOfMessagesSent;
}

