/*
 * Copyright (c) 2004, University of Illinois,Distributed Systems Group
 * Large & Dynamic Groups Size Estimation project members:
 * Dimitrios Psaltoulis
 * Dionysios Kostoulas
 * Indranil Gupta
 * Al Demers
 * Ken Birman
 *  All rights reserved.
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the
 * distribution.
 *
 * - Neither the name of the University of Illinois, Urbana-Champaign
 * nor the names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * peerCounter.java
 *
 * Created on April 5, 2004, 1:06 PM
 */

import java.lang.*;
import java.util.*;
import java.net.*;
import java.io.*;
import java.security.*;
import java.awt.event.*;

import SizeEstimationAlgorithm.*;
import SizeEstimationAlgorithm.HopCounting.*;
import SizeEstimationAlgorithm.IntervalCounting.*;

/**
 *
 * @author  Dimitrios Psaltoulis
 */
public class peerCounter extends javax.swing.JFrame {
    
    /** Creates new form peerCounter */
    public peerCounter() {
        initComponents();
        jTextArea1.append("Interface initialized\n");
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private javax.swing.SpinnerNumberModel model = new javax.swing.SpinnerNumberModel(32000, 1024, 65536, 1);
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel2 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        ActivateButton = new javax.swing.JButton();
        CountPeersButton = new javax.swing.JButton();
        ExitButton = new javax.swing.JButton();
        StopButton = new javax.swing.JButton();
        jSpinner1 = new javax.swing.JSpinner();
        jLabel8 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jTextField5 = new javax.swing.JTextField();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jCheckBox5 = new javax.swing.JCheckBox();
        jLabel9 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox(comboChoices);

        getContentPane().setLayout(new java.awt.GridLayout(1, 0));

        setTitle("Peer counter application");
        setMaximizedBounds(new java.awt.Rectangle(0, 0, 0, 0));
        setName("peerCount");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel6.setText("Status");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel2.add(jLabel6, gridBagConstraints);

        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        jScrollPane1.setMinimumSize(new java.awt.Dimension(30, 40));
        jTextArea1.setColumns(25);
        jTextArea1.setEditable(false);
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(20);
        jScrollPane1.setViewportView(jTextArea1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel2.add(jScrollPane1, gridBagConstraints);

        ActivateButton.setText("Activate");
        ActivateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ActivateButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanel2.add(ActivateButton, gridBagConstraints);

        CountPeersButton.setText("Count peers");
        CountPeersButton.setEnabled(false);
        CountPeersButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CountPeersButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        jPanel2.add(CountPeersButton, gridBagConstraints);

        ExitButton.setText("Exit");
        ExitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExitButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        jPanel2.add(ExitButton, gridBagConstraints);

        StopButton.setText("Stop");
        StopButton.setEnabled(false);
        StopButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StopButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        jPanel2.add(StopButton, gridBagConstraints);

        jSpinner1.setModel(model);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        jPanel2.add(jSpinner1, gridBagConstraints);

        jLabel8.setText("Server port: ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel8, gridBagConstraints);

        getContentPane().add(jPanel2);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMinimumSize(new java.awt.Dimension(447, 40));
        jPanel1.setPreferredSize(new java.awt.Dimension(4, 4));
        jLabel1.setText("Member 1 IP: ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel1, gridBagConstraints);

        jTextField1.setColumns(10);
        jTextField1.setMinimumSize(new java.awt.Dimension(10, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(jTextField1, gridBagConstraints);

        jLabel2.setText("Member 2 IP:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel2, gridBagConstraints);

        jTextField2.setColumns(10);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(jTextField2, gridBagConstraints);

        jLabel3.setText("Membership list");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        jPanel1.add(jLabel3, gridBagConstraints);

        jLabel4.setText("Member 3 IP:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel4, gridBagConstraints);

        jTextField3.setColumns(10);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(jTextField3, gridBagConstraints);

        jLabel5.setText("Member 4 IP:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel5, gridBagConstraints);

        jLabel7.setText("Member 5 IP:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel7, gridBagConstraints);

        jTextField4.setColumns(10);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(jTextField4, gridBagConstraints);

        jTextField5.setColumns(10);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(jTextField5, gridBagConstraints);

        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        jPanel1.add(jCheckBox1, gridBagConstraints);

        jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox2ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        jPanel1.add(jCheckBox2, gridBagConstraints);

        jCheckBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox3ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        jPanel1.add(jCheckBox3, gridBagConstraints);

        jCheckBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox4ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        jPanel1.add(jCheckBox4, gridBagConstraints);

        jCheckBox5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox5ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        jPanel1.add(jCheckBox5, gridBagConstraints);

        jLabel9.setText("Algorithm:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel1.add(jLabel9, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(jComboBox1, gridBagConstraints);

        getContentPane().add(jPanel1);

        pack();
    }//GEN-END:initComponents
    
    private void CountPeersButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CountPeersButtonActionPerformed
        // Add your handling code here:
        CountPeersButton.setEnabled(false);
        startClient(jComboBox1.getSelectedIndex());
        CountPeersButton.setEnabled(true);
    }//GEN-LAST:event_CountPeersButtonActionPerformed
    
    private void StopButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StopButtonActionPerformed
        // Add your handling code here:
        ActivateButton.setEnabled(true);
        CountPeersButton.setEnabled(false);
        StopButton.setEnabled(false);
        jSpinner1.setEnabled(true);
        stopServer();
        
    }//GEN-LAST:event_StopButtonActionPerformed
    
    private void ActivateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ActivateButtonActionPerformed
        // Add your handling code here:
        int sum = 0;
        for(int i=0;i<5;++i)
            if (members[i] != null)
                sum++;
        if( sum>0 ) {
            ActivateButton.setEnabled(false);
            StopButton.setEnabled(true);
            CountPeersButton.setEnabled(true);
            jSpinner1.setEnabled(false);
            startServer(jComboBox1.getSelectedIndex(), model.getNumber().intValue());
        }
    }//GEN-LAST:event_ActivateButtonActionPerformed
    
    private void ExitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExitButtonActionPerformed
        // Add your handling code here:
        if(!ActivateButton.isEnabled())
            stopServer();
        System.exit(0);
    }//GEN-LAST:event_ExitButtonActionPerformed
    
    private void jCheckBox5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox5ActionPerformed
        // Add your handling code here:
        if ( jTextField5.isEditable() ) {
            if (getAddress((jTextField5.getText()+":0"),5))
                jTextField5.setEditable(false);
            else {
                jCheckBox5.setSelected(false);
                members[4] = null;
            }
        }
        else if ( !jTextField5.isEditable() ) {
            jTextField5.setEditable( true );
            members[4] = null;
        }
    }//GEN-LAST:event_jCheckBox5ActionPerformed
    
    private void jCheckBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox4ActionPerformed
        // Add your handling code here:
        if ( jTextField4.isEditable() ) {
            if (getAddress((jTextField4.getText()+":0"),4))
                jTextField4.setEditable(false);
            else {
                jCheckBox4.setSelected(false);
                members[3] = null;
            }
        }
        else if ( !jTextField4.isEditable() ) {
            jTextField4.setEditable( true );
            members[3] = null;
        }
    }//GEN-LAST:event_jCheckBox4ActionPerformed
    
    private void jCheckBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox3ActionPerformed
        // Add your handling code here:
        if ( jTextField3.isEditable() ) {
            if ( getAddress((jTextField3.getText()+":0"),3))
                jTextField3.setEditable(false);
            else {
                jCheckBox3.setSelected(false);
                members[2] = null;
            }
        }
        else if ( !jTextField3.isEditable() ) {
            jTextField3.setEditable( true );
            members[2] = null;
        }
    }//GEN-LAST:event_jCheckBox3ActionPerformed
    
    private void jCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox2ActionPerformed
        // Add your handling code here:
        if ( jTextField2.isEditable() ) {
            if (getAddress((jTextField2.getText()+":0"),2))
                jTextField2.setEditable(false);
            else {
                jCheckBox2.setSelected(false);
                members[1] = null;
            }
        }
        else if ( !jTextField2.isEditable() ) {
            jTextField2.setEditable(true);
            members[1] = null;
        }
    }//GEN-LAST:event_jCheckBox2ActionPerformed
    
    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        // Add your handling code here:
        if ( jTextField1.isEditable() ) {
            if (getAddress((jTextField1.getText()+":0"),1))
                jTextField1.setEditable(false);
            else {
                jCheckBox1.setSelected(false);
                members[0] = null;
            }
        }
        else if ( !jTextField1.isEditable() ) {
            jTextField1.setEditable(true);
            members[0] = null;
        }
    }//GEN-LAST:event_jCheckBox1ActionPerformed
    
    public boolean getAddress(String s, int i) {
        StringTokenizer data = new StringTokenizer(s,":");
        try{
            InetAddress memberIP = InetAddress.getByName(data.nextToken());
            int memberPort = Integer.parseInt(data.nextToken());
            if (memberPort == 0)
                memberPort = GossipAlgorithm.DEFAULT_PORT;
            members[i-1] = new InetSocketAddress(memberIP, memberPort);
        }catch (UnknownHostException e) {
            jTextArea1.append("Invalid IP for member " + i + "\n");
            return false;
        }
        return true;
    }
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        if (args.length>0)
            commandLine(args);
        else
            new peerCounter().show();
    }
    
    public static void commandLine(String args[]) {
        boolean count = false;
        int algChoice;
        int serverPort;
        if (args[0].equals("-noGUI")) {
            if (args.length==1) {
                System.out.println("You should write the address of at least one peer. "+
                "Use the format IP_ADDRESS:PORT");
                System.exit(0);
            }
            int i=1;
            if (args[1].equals("-interval")) {
                algChoice = 1;
                i++;
            }
            else if (args[1].equals("-hop")) {
                algChoice = 0;
                i++;
            }
            else algChoice = 0;
            StringTokenizer data = new StringTokenizer(args[i]+':',":");
            if (data.nextToken().equals("-port")) {
                serverPort = Integer.parseInt(data.nextToken());
                i++;
            }
            else
                serverPort = GossipAlgorithm.DEFAULT_PORT;
            
            if (args[i].equals("-count")){
                count = true;
                i++;
            }
            for (int k=0; i < args.length; i++) {
                members[k] = getSocketAddress(args[i]);
                k++;
            }
            startServer(algChoice, serverPort);
            if (count) {
                alg.startCounting();
            }
        }
        else if (args[0].equals("-help")) {
            System.out.println("You can either use the GUI version by executing the jar file " +
            "or the command line version by using the -noGUI parameter plus the address of the peers "+
            "by using the format IP_ADDRESS:PORT.\n" +
            "e.g. java -jar peerCounter.jar -noGUI -hop -port:32000 -count 127.0.0.1:32000 68.169.0.7:32001");
        }
        else
            System.out.println("Error. Use the help parameter to see options.\n " +
            "java -jar peerCounter.jar -help");
    }
    
    public static InetSocketAddress getSocketAddress(String address) {
        address+=":0";
        StringTokenizer data = new StringTokenizer(address,":");
        InetAddress memberIP=null;
        try{
            memberIP = InetAddress.getByName(data.nextToken());
        }catch (UnknownHostException e) {
            System.out.println("Invalid IP address: " + e);
        }
        int memberPort = Integer.parseInt(data.nextToken());
        if (memberPort == 0)
            memberPort = GossipAlgorithm.DEFAULT_PORT;
        return (new InetSocketAddress(memberIP, memberPort));
    }
    
    public void startClient(int algChoice) {
        alg.startCounting();
        displayResultsGUI(algChoice);
    }
    
    public void displayResultsGUI(int algChoice) {
        if (algChoice==1) {
            final IntervalCountingAlgorithm a = (IntervalCountingAlgorithm)alg;
            
            int delay = 4000;
            ActionListener taskPerformer = new ActionListener() {
                long size=0;
                boolean done=false;
                int k=0;
                public void actionPerformed(ActionEvent e) {
                    long newSize = a.getSize();
                    if (size==newSize)
                        done=true;
                    else
                        size=newSize;
                    if((k<60)&&(!done)) {
                        jTextArea1.append("Network size: " + size + "\n\n");
                        k++;
                    }
                }
            };
            javax.swing.Timer t = new javax.swing.Timer(delay, taskPerformer);
            t.start();
        }
        else {
            final HopCountingAlgorithm a = (HopCountingAlgorithm)alg;
            
            int delay = 2000;
            ActionListener taskPerformer = new ActionListener() {
                long size=0;
                long sizeS=0;
                boolean done=false;
                int k=0;
                public void actionPerformed(ActionEvent e) {
                    long newSize = a.getSize();
                    long newSizeS = a.getSizeS();
                    if ((size==newSize)&&(sizeS==newSizeS))
                        done=true;
                    else {
                        size=newSize;
                        sizeS=newSizeS;
                    }
                    if((k<60)&&(!done)) {
                        jTextArea1.append("Network size: " + size + "\nNetwork size(S): " + sizeS +"\n\n");
                        k++;
                    }
                }
            };
            javax.swing.Timer t = new javax.swing.Timer(delay, taskPerformer);
            t.start();
        }
        
    }
    
    public static void startServer(int algChoice, int serverPort) {
        switch (algChoice) {
            case 1: alg = new IntervalCountingAlgorithm(members, serverPort);
            break;
            case 0:
            default: alg = new HopCountingAlgorithm(members, serverPort);
            break;
        }
        //        alg.activate();
    }
    
    public void stopServer() throws NullPointerException {
        alg.stop();
        jTextArea1.append("Server stopped\n\n");
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton ActivateButton;
    private javax.swing.JButton CountPeersButton;
    private javax.swing.JButton ExitButton;
    private javax.swing.JButton StopButton;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    // End of variables declaration//GEN-END:variables
    
    private String[] comboChoices = {"Hop Counting","Interval Density"};
    private static InetSocketAddress members[] = new InetSocketAddress[5];
    private static GossipAlgorithm alg;
}
